// Leistungsvergleich List-Implementierungen

import java.util.*;

class Listen {
	static final int ANZ = 40_000;

	static void testList(List<String> plis) {
		StringBuilder sb = new StringBuilder();
		Random ran = new Random();

		// Füllen
		System.out.println("Kollektionsklasse:\t" + plis.getClass());
		long start = System.currentTimeMillis();
		for (int i = 0; i < ANZ; i++) {
			sb.delete(0, 6);
			for (int j = 0; j < 5; j++)
				sb.append((char) (65 + ran.nextInt(26)));
			plis.add(sb.toString());
		}
		System.out.println(" Zeit zum Füllen:\t" +
				(System.currentTimeMillis() - start));
		
		// Abrufen per Index-Zugriff
		start = System.currentTimeMillis();
		for (int i = 0; i < ANZ; i++)
			plis.get(ran.nextInt(ANZ));
		System.out.println(" Zeit zum Abrufen:\t" +
				(System.currentTimeMillis() - start));

		// Einfügen am Listenanfang
		start = System.currentTimeMillis();
		for (int i = 0; i < ANZ; i++)
			plis.add(0, "neu");
		System.out.println(" Zeit zum Einfügen:\t" +
				(System.currentTimeMillis() - start));
		
		// Löschen am Listenanfang
		start = System.currentTimeMillis();
		for (int i = 0; i < 2*ANZ; i++)
			plis.remove(0);
		System.out.println(" Zeit zum Löschen:\t" +
				(System.currentTimeMillis() - start) + "\n");
	}

	public static void main(String[] args) {
		System.out.println("Warmlaufen:\n");
		testList(new ArrayList<String>());
		testList(new Vector<String>());
		testList(new LinkedList<String>());
		System.out.println("Verwertbare Testergebnisse:\n");
		testList(new ArrayList<String>());
		testList(new Vector<String>());
		testList(new LinkedList<String>());
	}
}
