import java.util.concurrent.Callable;
import java.util.concurrent.TimeoutException;

class RandomNumberCruncher implements Callable<Double> {
    public Double call() throws TimeoutException {
        final int mxNum = 100_000_000;
        final int mxTime = 5_000;
        double d = 0.0;
        long start = System.currentTimeMillis();
        for (int i = 0; i < mxNum; i++) {
            d += Math.random();
            if (System.currentTimeMillis() - start > mxTime)
                throw new TimeoutException();
        }
        return d/mxNum;
    }
}