package de.uni_trier.zimk.matrain.br;

import de.uni_trier.zimk.util.conio.Simput;

public class Bruch {
    private int zaehler;          // wird automatisch mit 0 initialisiert
    private int nenner = 1;       // wird manuell mit 1 initialisiert
    private String etikett = "";  // die Referenztyp-Init. auf null wird ersetzt

    public Bruch(int z, int n, String eti) {
        setzeZaehler(z);
        setzeNenner(n);
        setzeEtikett(eti);
    }

    public Bruch() {}

    public void setzeZaehler(int z) {zaehler = z;}

    public boolean setzeNenner(int n) {
        if (n != 0)	{
            nenner = n;
            return true;
        } else
            return false;
    }

    public void setzeEtikett(String eti) {
        if (eti.length() <= 40)
            etikett = eti;
        else
            etikett = eti.substring(0, 40);
    }

    public int gibZaehler() {return zaehler;}

    public int gibNenner()	{return nenner;}

    public String gibEtikett()	{return etikett;}

    public void kuerze() {
        if (zaehler != 0) {
            int rest;
            int ggt = Math.abs(zaehler);
            int divisor = Math.abs(nenner);
            do {
                rest = ggt % divisor;
                ggt = divisor;
                divisor = rest;
            } while (rest > 0);
            zaehler /= ggt;
            nenner  /= ggt;
        } else
            nenner = 1;
    }

    public void addiere(Bruch b) {
        zaehler = zaehler*b.nenner + b.zaehler*nenner;
        nenner = nenner*b.nenner;
        kuerze();
    }

    public void addiere(Bruch... bar) {
        for (Bruch b : bar)
            addiere(b);
    }

    public boolean addiere(int z, int n, boolean autokurz) {
        if (n != 0) {
            zaehler = zaehler*n + z*nenner;
            nenner = nenner*n;
            if (autokurz)
                kuerze();
            return true;
        } else
            return false;
    }


    public void frage() {
        int n;
        do {
            System.out.print("Zähler: ");
            setzeZaehler(Simput.gint());
        } while (Simput.checkError());
        do {
            System.out.print("Nenner: ");
            n = Simput.gint();
            if (n == 0 && !Simput.checkError())
                System.out.println("Der Nenner darf nicht Null werden!\n");
        } while (n == 0);
        setzeNenner(n);
    }

    public void zeige() {
        String luecke = "";
        int el = etikett.length();
        for (int i=1; i<=el; i++)
            luecke = luecke + " ";
        System.out.println(" " + luecke  + "   " + zaehler + "\n" +
                " " + etikett + " -----\n" +
                " " + luecke  + "   " + nenner + "\n");
    }

    public void dupliziere(Bruch bc) {
        bc.zaehler = zaehler;
        bc.nenner = nenner;
        bc.etikett = etikett;
    }
}
